/** radio8 app:
This app allows realtime status updates between up to 8 devices.


== Description ==

Currently we are testing sequencing, to ensure all devices get time to speak.

*/

/** Dependencies **************************************************************/

#include "radio8.h"
#include <usb.h>
#include <usb_com.h>

#include <stdio.h>
#include <string.h>

/** Functions *****************************************************************/

void main( void ) {	
	uint8 DATA tmp;
	
	
	systemInit();
	usbInit();
	radioMacInit();
	radioInitAddendum();
	radioMacStrobe();

	while(1){
		boardService();
		//usbShowStatusWithGreenLed();
		usbComService();
		
		#if 1
		if(usbComTxAvailable() > 50){
			/* Events can get lost here, if they occur while this is running, or occur twice
			before this can handle them. However, this is a realtime system, so we should
			just drop the extra events and handle what we can. */
			switch( respond_state ) {
				case MESSAGE_RCV:
					usbComTxSendByte(rx_packet[1]);
					break;
				
				default:
					break;
			}
			respond_state = 0;
		}
		#endif
		
		if( usbComRxAvailable() && !radio_tx_available) {
			tmp = usbComRxReceiveByte();
			usbComTxSendByte( tmp );
			tx_packet[1] = tmp;
			tx_packet[0] = 1;
			radio_tx_available = 1;
		}
		
	}
}